"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// node_modules/.pnpm/tsup@8.0.2_supports-color@9.4.0_typescript@5.3.3/node_modules/tsup/assets/cjs_shims.js
var getImportMetaUrl = () => typeof document === "undefined" ? new URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;
var importMetaUrl = /* @__PURE__ */ getImportMetaUrl();

// src/utils/filesystem.ts
var _fs = require('fs'); var _fs2 = _interopRequireDefault(_fs);
var _path = require('path'); var _path2 = _interopRequireDefault(_path);
var _url = require('url');
function hasErrorCode(error, code) {
  return (error == null ? void 0 : error.code) === code;
}
async function fileExists(filePath) {
  try {
    await _fs2.default.promises.stat(filePath);
    return true;
  } catch (error) {
    if (hasErrorCode(error, "ENOENT")) {
      return false;
    }
    throw error;
  }
}
async function forEachDirentAsync(dirPath, action) {
  let dirFiles = [];
  try {
    dirFiles = await _fs2.default.promises.readdir(dirPath, { withFileTypes: true });
  } catch (error) {
  }
  await Promise.all(dirFiles.map(action));
}
async function readDirectory(dirPath) {
  try {
    const files = await _fs2.default.promises.readdir(dirPath);
    return files;
  } catch (error) {
    if (hasErrorCode(error, "ENOENT") || hasErrorCode(error, "ENOTDIR")) {
      return [];
    }
    throw error;
  }
}
async function removeEmptyDirsUp(checkedDirs, dirPath, count = 0) {
  if (!checkedDirs.has(dirPath)) {
    const files = await readDirectory(dirPath);
    const emptyDir = files.length === 0;
    checkedDirs.add(dirPath);
    if (emptyDir) {
      try {
        await _fs2.default.promises.rmdir(dirPath);
        count++;
      } catch (error) {
      }
      const parentDir = _path2.default.dirname(dirPath);
      count = await removeEmptyDirsUp(checkedDirs, parentDir, count);
    }
  }
  return count;
}
async function removeEmptyDirs(filePaths) {
  let removedEmptyDirs = 0;
  await Promise.all(
    filePaths.map(async (filePath) => {
      const removedParentDirs = await removeEmptyDirsUp(/* @__PURE__ */ new Set(), _path2.default.dirname(filePath));
      removedEmptyDirs += removedParentDirs;
    })
  );
  return removedEmptyDirs;
}
async function crawlDirFast(filePaths, dirPath) {
  await forEachDirentAsync(dirPath, async (dirent) => {
    const nextPath = dirPath + _path2.default.sep + dirent.name;
    if (dirent.isDirectory()) {
      await crawlDirFast(filePaths, nextPath);
    } else {
      filePaths.push(nextPath);
    }
  });
}
async function crawlDirWithChecks(filePaths, dirPath, checkDir, checkFile) {
  await forEachDirentAsync(dirPath, async (nextPathDirent) => {
    const nextPath = dirPath + _path2.default.sep + nextPathDirent.name;
    if (nextPathDirent.isDirectory()) {
      if (checkDir(nextPath)) {
        await crawlDirFast(filePaths, nextPath);
      } else {
        await crawlDirWithChecks(filePaths, nextPath, checkDir, checkFile);
      }
    } else if (checkFile(nextPath)) {
      filePaths.push(nextPath);
    }
  });
  return filePaths;
}
async function removeFiles(filePaths, options = {}) {
  let reducedSize = 0;
  await Promise.all(
    filePaths.map(async (filePath) => {
      try {
        const fileStats = await _fs2.default.promises.stat(filePath);
        if (!options.dryRun) {
          await _fs2.default.promises.unlink(filePath);
        }
        reducedSize += fileStats.size;
      } catch (error) {
      }
    })
  );
  return reducedSize;
}
function fileDir(importMetaUrl2) {
  return _path2.default.dirname(_url.fileURLToPath.call(void 0, importMetaUrl2));
}

// src/shared.ts

var DEFAULT_GLOBS_FILE_PATH = _path2.default.resolve(
  fileDir(importMetaUrl),
  "..",
  ".cleanmodules-default"
);
var sharedDefaultOptions = {
  directory: _path2.default.resolve(process.cwd(), "node_modules"),
  globFile: ".cleanmodules",
  noDefaults: false,
  globs: []
};

// src/utils/glob.ts


var _picomatch = require('picomatch'); var _picomatch2 = _interopRequireDefault(_picomatch);
function initGlobLists() {
  return { excluded: [], included: [], includedDirs: [], originalIncluded: [] };
}
var DEFAULT_PICO_OPTIONS = {
  dot: true,
  nocase: true,
  strictSlashes: true
};
function makeGlobMatcher(globs, picoOptions) {
  return _picomatch2.default.call(void 0, globs, { ...DEFAULT_PICO_OPTIONS, ...picoOptions });
}
function updateGlobLists(globLists, updateFunc) {
  const { included, includedDirs, excluded } = globLists;
  return {
    ...globLists,
    included: updateFunc(included, "included"),
    includedDirs: includedDirs ? updateFunc(includedDirs, "includedDirs") : includedDirs,
    excluded: updateFunc(excluded, "excluded")
  };
}
function mergeGlobLists(globListsA, globListsB) {
  return {
    ...updateGlobLists(globListsA, (globs, key) => [...globs, ...globListsB[key] || []]),
    originalIncluded: [...globListsA.originalIncluded, ...globListsB.originalIncluded]
  };
}
function toPosixPath(pathStr) {
  return _path2.default.sep === "/" ? pathStr : pathStr.replace(/\\/g, "/");
}
function toAbsoluteGlobLists(globLists, absoluteNodeModulesPath) {
  const absolutePathWithPosixSeparator = toPosixPath(absoluteNodeModulesPath);
  return updateGlobLists(
    globLists,
    (globs) => globs.map((glob) => absolutePathWithPosixSeparator + "/" + glob)
  );
}
function wrapGlobs(globs, prefix) {
  return `${prefix || ""}@(${globs.map((glob) => "(" + glob + ")").join("|")})`;
}
var GLOBSTAR_START_REGEX = /^(\/?\*\*\/)+/;
function optimizeGlobs(globs) {
  const globstarStartGlobs = [];
  const fixedPathGlobs = [];
  for (const glob of globs) {
    if (glob.match(GLOBSTAR_START_REGEX)) {
      globstarStartGlobs.push(glob);
    } else {
      fixedPathGlobs.push(glob);
    }
  }
  const result = [];
  if (globstarStartGlobs.length) {
    const withoutGlobstar = globstarStartGlobs.map((glob) => glob.replace(GLOBSTAR_START_REGEX, ""));
    result.push(wrapGlobs(withoutGlobstar, "**/"));
  }
  if (fixedPathGlobs.length) {
    result.push(wrapGlobs(fixedPathGlobs));
  }
  return result;
}
function optimizeGlobLists(globLists) {
  return updateGlobLists(globLists, optimizeGlobs);
}
var EXCLAMATION_START = /^\s*!/;
var DIR_GLOB_REGEX = /\/\**$/;
var EXCLUDED_GLOB_REGEX = /^!/;
var ESCAPED_NEGATIVE_GLOB_REGEX = /^\\!/;
var NOT_FIXED_START_GLOB_REGEX = /^([^/])/;
var FIXED_START_GLOB_REGEX = /^\//;
function formatGlob(glob) {
  return glob.trim().replace(EXCLUDED_GLOB_REGEX, "").replace(ESCAPED_NEGATIVE_GLOB_REGEX, "!").replace(DIR_GLOB_REGEX, "/**").replace(NOT_FIXED_START_GLOB_REGEX, "**/$1").replace(FIXED_START_GLOB_REGEX, "");
}
function processGlobs(globs) {
  const globLists = initGlobLists();
  for (const glob of globs) {
    const isExcluded = !!glob.match(EXCLAMATION_START);
    const formattedGlob = formatGlob(glob);
    if (!formattedGlob) {
      continue;
    }
    if (isExcluded) {
      globLists.excluded.push(formattedGlob);
    } else {
      if (formattedGlob.endsWith("/**")) {
        globLists.includedDirs.push(formattedGlob.replace(DIR_GLOB_REGEX, ""));
      }
      globLists.included.push(formattedGlob);
      globLists.originalIncluded.push(glob.trim());
    }
  }
  return globLists;
}
var COMMENT_OR_EMPTY_REGEX = /^\s*(#|$)/;
async function parseGlobsFile(filePath) {
  let fileContents;
  try {
    fileContents = (await _fs.promises.readFile(filePath, { encoding: "utf-8" })).toString() || "";
  } catch (error) {
    console.error(`Failed to read glob file (${filePath})`);
    throw error;
  }
  const fileGlobs = fileContents.split(/\r?\n/).filter((line) => !line.match(COMMENT_OR_EMPTY_REGEX)) || [];
  return processGlobs(fileGlobs);
}
async function parseDefaultGlobsFile() {
  return parseGlobsFile(DEFAULT_GLOBS_FILE_PATH);
}
async function getGlobLists({
  noDefaults,
  globFile,
  globs
}) {
  const globListsToMerge = [];
  if (!noDefaults) {
    const defaultGlobLists = await parseDefaultGlobsFile();
    globListsToMerge.push(defaultGlobLists);
  }
  if (globFile && await fileExists(globFile)) {
    const userFileGlobLists = await parseGlobsFile(globFile);
    globListsToMerge.push(userFileGlobLists);
  }
  if (globs == null ? void 0 : globs.length) {
    const argGlobsLists = processGlobs(globs);
    globListsToMerge.push(argGlobsLists);
  }
  return globListsToMerge.reduce(
    (mergedGlobLists, globLists) => mergeGlobLists(mergedGlobLists, globLists),
    initGlobLists()
  );
}
async function findFilesByGlobLists(directory, globLists) {
  const { included, includedDirs, excluded } = toAbsoluteGlobLists(
    optimizeGlobLists(globLists),
    directory
  );
  const picoOptions = { ignore: excluded };
  const checkDir = (includedDirs == null ? void 0 : includedDirs.length) ? makeGlobMatcher(includedDirs, picoOptions) : () => false;
  const checkFile = makeGlobMatcher(included, picoOptions);
  let filesToRemove = await crawlDirWithChecks([], directory, checkDir, checkFile);
  if (excluded.length) {
    filesToRemove = filesToRemove.filter((file) => checkFile(file));
  }
  return filesToRemove;
}

// src/analyze.ts
async function analyze(options = {}) {
  const mergedOptions = { ...sharedDefaultOptions, ...options };
  const { globs, noDefaults, globFile, directory } = mergedOptions;
  const nodeModulesPath = directory || sharedDefaultOptions.directory;
  const globLists = await getGlobLists({ globs, noDefaults, globFile });
  const includedFiles = await findFilesByGlobLists(nodeModulesPath, globLists);
  const defaultGlobs = toAbsoluteGlobLists(
    optimizeGlobLists(await parseDefaultGlobsFile()),
    nodeModulesPath
  );
  const includedByDefaultMatcher = makeGlobMatcher(defaultGlobs.included, {
    ignore: defaultGlobs.excluded
  });
  const globMatchers = globLists.included.map((glob, index) => {
    const absoluteGlob = toPosixPath(nodeModulesPath) + "/" + glob;
    const matcher = makeGlobMatcher(absoluteGlob);
    return { original: globLists.originalIncluded[index], derived: absoluteGlob, matcher };
  });
  const analyzedResults = includedFiles.map((filePath) => {
    const includedByDefault = includedByDefaultMatcher(filePath);
    const includedByGlobs = [];
    for (const { original, derived, matcher } of globMatchers) {
      if (matcher(filePath)) {
        includedByGlobs.push({ original, derived });
      }
    }
    return { filePath, includedByDefault, includedByGlobs };
  });
  return analyzedResults;
}

// src/clean.ts
var defaultCleanOptions = {
  ...sharedDefaultOptions,
  dryRun: false,
  keepEmpty: false
};
async function clean(options = {}) {
  const mergedOptions = { ...defaultCleanOptions, ...options };
  const { globs, noDefaults, globFile, directory, dryRun, keepEmpty } = mergedOptions;
  const globLists = await getGlobLists({ globs, noDefaults, globFile });
  const files = await findFilesByGlobLists(directory, globLists);
  const reducedSize = await removeFiles(files, { dryRun });
  const removedEmptyDirs = dryRun || keepEmpty ? 0 : await removeEmptyDirs(files);
  return { files, reducedSize, removedEmptyDirs };
}








exports.importMetaUrl = importMetaUrl; exports.fileDir = fileDir; exports.sharedDefaultOptions = sharedDefaultOptions; exports.analyze = analyze; exports.defaultCleanOptions = defaultCleanOptions; exports.clean = clean;
